﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;

namespace ExpressionTrees
{
    public class Solution
    {
        public static void TestSolution()
        {
            var people = new List<Person>
            {
                new Person("Thomas", 26, false),
                new Person("Daisy", 23, true),
                new Person("John", 32, false),
                new Person("Kate", 18, false)
            };

            var paramExpression = Expression.Parameter(typeof(Person), "person");

            var constExpression1 = Expression.Constant(19);
            var constExpression2 = Expression.Constant(25);
            var constExpression3 = Expression.Constant(true);

            var agePropExpression = Expression.PropertyOrField(paramExpression, nameof(Person.Age));
            var isSinglePropExpression = Expression.PropertyOrField(paramExpression, nameof(Person.IsSingle));

            var binaryExpression1 = Expression.GreaterThanOrEqual(agePropExpression, constExpression1);
            var binaryExpression2 = Expression.LessThanOrEqual(agePropExpression, constExpression2);
            var binaryExpression3 = Expression.Equal(isSinglePropExpression, constExpression3);

            var ageConditionExpression = Expression.AndAlso(binaryExpression1, binaryExpression2);
            var overallConditionExpression = Expression.OrElse(ageConditionExpression, binaryExpression3);

            var predicate = Expression.Lambda<Func<Person, bool>>(overallConditionExpression, paramExpression).Compile();
            var result = people.Where(predicate).Select(person => person.Name).ToList();
            Console.WriteLine(result.First());
            Console.ReadKey();
        }
    }
}