﻿using System;
using System.Linq;
using System.Reflection;

namespace Reflection
{
    public class Solution
    {
        public void DynamicallySetCustomerPropertyViaPrivateSetter()
        {
            var customer = new Customer("Elvis");
            var propInfo = typeof(Customer).GetProperty(nameof(Customer.SomeValue));
            propInfo?.SetValue(customer, 20);
            Console.WriteLine(customer.SomeValue);
        }

        public void DynamicallyInvokeStaticCustomerMethod()
        {

            MethodInfo? voidMethodInfo = typeof(Customer).GetMethod("ImportantPrivateStaticVoidMethod", BindingFlags.Static | BindingFlags.NonPublic);
            voidMethodInfo?.Invoke(null, new object[] { 42, "text" });
        }

        public void GetAllNonAbstractClassesImplementingIAnimal()
        {
            var className = Assembly
                .GetExecutingAssembly()
                .GetTypes()
                .FirstOrDefault(mytype => mytype.GetInterfaces().Contains(typeof(IAnimal)) && !mytype.IsAbstract)?.Name;
            Console.WriteLine(className);
        }
    }
}
